<div class="container mx-auto flex flex-col items-center bg-gray-100 p-4 max-w-5xl">
  <div *ngIf="!pageLoaded"
       class="fixed w-100 h-100 opacity-80 bg-purple-800 inset-0 z-50 flex items-center justify-center">
    <svg class="animate-spin -ml-1 mr-3 h-12 w-12 text-white" xmlns="http://www.w3.org/2000/svg" fill="none"
         viewBox="0 0 24 24">
      <circle class="opacity-25" cx="12" cy="12" r="10" stroke="currentColor" stroke-width="4"></circle>
      <path class="opacity-75" fill="currentColor"
            d="M4 12a8 8 0 018-8V0C5.373 0 0 5.373 0 12h4zm2 5.291A7.962 7.962 0 014 12H0c0 3.042 1.135 5.824 3 7.938l3-2.647z"></path>
    </svg>
  </div>
  <div class="container">
    <app-ticker-input
      [existingTickers]="tickerObjects"
      (addTickerEvent)="handleAddTicker($event)"
    >
    </app-ticker-input>

    <ng-container *ngIf="tickerObjects.length > 0">
      <hr class="w-full border-t border-gray-600 my-4"/>
      <app-filter
        [tickersList]="tickerObjects"
        [filterInitialState]="filter"
        (filterUpdated)="handleFilterUpdate($event)"
      >
      </app-filter>

      <app-pagination
        [tickersLimit]="6"
        [tickersList]="filteredTickers"
        [initialPageState]="page"
        (paginationUpdated)="handlePagination($event)"
      >
      </app-pagination>

      <hr class="w-full border-t border-gray-600 my-4"/>

      <app-tickers-listing
        [tickers]="paginatedTickers"
        [unselectTicker]="selectedTicker == null"
        (tickerSelected)="setSelectedTicker($event)"
        (tickerUnselected)="setSelectedTicker(null)"
        (removeTicker)="removeTicker($event)"
      >
      </app-tickers-listing>
      <hr class="w-full border-t border-gray-600 my-4"/>

      <app-graph
        *ngIf="selectedTicker"
        [fromCurrencyName]="selectedTicker ? selectedTicker.name : null"
        [graphValues]="selectedTickerPricesList"
        [toCurrencyName]="'USD'"
        (graphClosed)="handleCloseGraph()">
      </app-graph>

    </ng-container>
  </div>
</div>

<router-outlet></router-outlet>
